package sun.tracing;

import java.util.Iterator;
import java.lang.reflect.Method;
import com.sun.tracing.Provider;
import java.util.Set;

class MultiplexProvider extends ProviderSkeleton
{
    private Set<Provider> providers;
    
    @Override
    protected ProbeSkeleton createProbe(Method method) {
        return new MultiplexProbe(method, this.providers);
    }
    
    MultiplexProvider(Class<? extends Provider> clazz, Set<Provider> providers) {
        super(clazz);
        this.providers = providers;
    }
    
    @Override
    public void dispose() {
        Iterator<Provider> iterator = this.providers.iterator();
        while (iterator.hasNext()) {
            ((Provider)iterator.next()).dispose();
        }
        super.dispose();
    }
}
